Option Explicit

Call Main

'*****************************************************************
'This script file mimics Make_EXE.bat
'*****************************************************************
Sub Main

    'The names indicate the intended data type
    Dim WshShell	'Windows scripting shell processor
    Dim fso			'Instance of file scripting object
    Dim fsoFile		'File object created from fso
    Dim liResp		'Return code from MsgBox
    Dim lsZipName	'Name of Zip file To extract source
    Dim loReturn	'Object for handle to program

'*****************************************************************

    'Test to be sure the ZIP file exists - may forget to change name!
    lsZipName = "Jcopy 2_5_27 source.zip"

    'Script simply aborts if file is not found
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set fsoFile = fso.GetFile("E:\Data\VB60\Jcopy\"+lsZipName)
    
    'Create instance of Shell to run external programs
    Set WshShell = WScript.CreateObject("WScript.Shell")

'*****************************************************************

    'This waits for the process to finish, based on third parameter [optional]
    'First update the ZIP file
    WshShell.Run "D:\Apps\PKWARE\Pkzip25\Pkzip25 -add=freshen " & _
    	CHR(34) & "E:\Data\VB60\Jcopy\" & lsZipName & CHR(34) & _
    	" E:\Data\VB60\Jcopy\*.*" ,,True 

    'Now extract its contents
    WshShell.Run "D:\Apps\PKWARE\Pkzip25\Pkzip25 -extract -over=all " & _
    	CHR(34) & "E:\Data\VB60\Jcopy\" & lsZipName & CHR(34) & _
    	" " & CHR(34) & "E:\Data\VB60\Jcopy\EXEsource" & CHR(34),,True

    'Now delete extra copy of this script - avoid confusion!
    fso.DeleteFile "E:\Data\VB60\Jcopy\EXEsource\Make_exe.vbs", True
  
'*****************************************************************

    'This waits for the process to finish, based on third parameter
    'Part of this MUST use short file names, maybe due to length!
    WshShell.Run Chr(34) & _
    	"D:\Program Files\Compuware\FailSafe\FailSafe.exe" & _
    	CHR(34) & " /F E:\Data\VB60\Jcopy\EXESOU~1\FailSafe.INI " & _
    	"/A E:\Data\VB60\Jcopy\EXESOU~1\FSLite~1.vbp",,True

'Long file name tests
'FAILS    WshShell.Run Chr(34) & "D:\Program Files\Compuware\FailSafe\FailSafe.exe" & CHR(34) & " /F " & CHR(34) & "E:\Data\VB60\Jcopy\EXESource\FailSafe.INI" & CHR(34) & "  /A E:\Data\VB60\Jcopy\EXESOU~1\FSLite~1.vbp",,True
'FAILS    WshShell.Run Chr(34) & "D:\Program Files\Compuware\FailSafe\FailSafe.exe" & CHR(34) & " /F E:\Data\VB60\Jcopy\EXESOU~1\FailSafe.INI /A " & CHR(34) & "E:\Data\VB60\Jcopy\EXESource\FS Lite - small EXE.vbp" & CHR(34),,True

'*****************************************************************

    'This must NOT wait for the process to finish ...
    'Otherwise, the next code section can't SendKeys to NotePad!
    loReturn = WshShell.Run ("C:\Windows\Notepad.EXE " + CHR(34) + _
    	"E:\Data\VB60\Jcopy\EXESource\FS Lite - small EXE.vbp" + _
    	CHR(34),,False)

	'OK, now ready to automate NotePad
	liResp = WshShell.Popup( "Use NotePad to " & _
		"update version number: " & MID(lsZipName,7,6), 4, _
		"4 second time-out",  vbYesno + vbInformation)
    'Default is -1 if nothing is pressed
    If liResp = vbNo Then WScript.Quit

    'Now search and replace the version number
    WshShell.AppActivate loReturn    

    'Second parameter on SendKeys should force wait
    'for processing of the keystrokes sent - does NOT!
    'That's why I have the Wscript.Sleep calls below
    
    'ALT-E, R For replace
    WshShell.SendKeys "%E", True
    WshShell.SendKeys "R", True
    WScript.Sleep(1000)
    liResp = MID(lsZipName,11,2) - 1
    WshShell.SendKeys "RevisionVer=" & liResp, True
    WshShell.SendKeys "{TAB}", True
    WScript.Sleep(1000)

    liResp = MID(lsZipName,11,2)
    WshShell.AppActivate loReturn
    WshShell.SendKeys "RevisionVer=" & liResp, True
    WshShell.SendKeys "{TAB}", True
    WScript.Sleep(1000)

    'ALT-A to replace all
    WshShell.AppActivate loReturn
    WshShell.SendKeys "%A", True
    'Handle the message box
    WshShell.SendKeys "~", True
    'If no matches, need to clear search dialog
    WshShell.SendKeys "{ESC}", True    

	'Now save the file and exit
    WshShell.AppActivate loReturn
    'ALT-F, S to save
    WshShell.SendKeys "%F", True
    WshShell.SendKeys "S", True
    WScript.Sleep(1000)
    WshShell.SendKeys "%{F4}", True   

'*****************************************************************

	'Now can compile the modified code
    liResp = WshShell.Popup ("Ready for VB6? (5 seconds)" , 5, _
    	"Fail Safe finished", vbYesno + vbInformation)
    If liResp = vbNo Then WScript.Quit

    'This waits for the process to finish, based on third parameter
    WshShell.Run CHR(34) & _
    	"D:\Program Files\Microsoft Visual Studio\VB98\VB6.exe" & _
    	CHR(34) & " " & CHR(34) & "E:\Data\VB60\Jcopy\EXESource\" & _
    	"FS Lite - small EXE.vbp" & CHR(34) & " /make",,True

'*****************************************************************

	'Now can create the setup packages
	liResp = WshShell.Popup ("Ready for Wise? (5 seconds)" , 5, _
    	"VB6 finished", vbYesno + vbInformation)
    If liResp = vbNo Then WScript.Quit
    	
    'This waits for the process to finish, based on third parameter
    WshShell.Run CHR(34) & "D:\Program Files\Wise " & _
    	"InstallBuilder\WISE32.EXE" &CHR(34) & " /c " & _
    	"E:\Data\VB60\Jcopy\EXEsource\Setup.wse",,True

'*****************************************************************
    
	'Now create the Zip files for downloading
	WshShell.Run "D:\Apps\PKWARE\Pkzip25\Pkzip25 -add=freshen " & _
    	"E:\Data\VB60\Jcopy\EXEsource\jcopybig.ZIP " & _ 
    	"E:\Data\VB60\Jcopy\EXEsource\*.*",,True
    	
    WshShell.Run "D:\Apps\PKWARE\Pkzip25\Pkzip25 -add=freshen " & _
    	"E:\Data\VB60\Jcopy\EXEsource\jcopysml.ZIP " & _
    	"E:\Data\VB60\Jcopy\EXEsource\*.*",,True

	liResp = WshShell.Popup( _
	    "Remember to load Front Page first" & vbnewline & _
    	"Then manually copy Zip file and paste into ..\vb folder", _
		5, "5 second time-out", vbOkonly )
    
End Sub